#! /usr/bin/env python

# Scrivere una classe che data una lista o un file di parole stampi gli anagrammi 

#Come ulteriore esercizio, partendo da questi metodi, modificarlo in modo che data una parola, trovi gli anagrammi solo di quella parola


class Anagramma:
    def __init__(self):
        self.d = {}
        
    def _ordina(self, s):
        "ordina una stringa e la ritorna"
        t = list(s)
        t.sort()
        t = ''.join(t)
        return t

    def calcola_anagrammi_lista(self, lista):
        self.d.clear()
        for w in lista:
            self._addword(w.strip().lower())
            
    def calcola_anagrammi(self, filename):
        self.d.clear()
        with open(filename) as f:
            for linea in f:
                parola = linea.strip().lower()
                self._addword(parola)
            
    def _addword(self, parola):
        t = self._ordina(parola)

        if t not in self.d:
            self.d[t] = [parola]
        else:
            self.d[t].append(parola)

    def stampa_anagrammi(self):
        for v in self.d.values():
            if len(v) > 1:
                print len(v), v

    def stampa_anagrammi_in_ordine(self, mingrammi=-1):
        """stampa gli anagrammi in ordine decrescente. se mingrammi e' specificato
        stampa solo quelli con numero superiore a mingrammi"""
        t = []
        for v in self.d.values():
            if len(v) > 1 and (mingrammi<=0 or len(v)>=mingrammi):
                t.append((len(v), v))
        t.sort(reverse=True)
        for x in t:
            print x



if __name__ == "__main__":
	a=Anagramma()
	a.calcola_anagrammi('words_italiano.txt')
	a.stampa_anagrammi_in_ordine(4)
