#~ Costruire un dizionario di studenti in cui la chiave e' la matricola ed il valore e' una lista di tuple del tipo (nomeesame, voto).
#~ Creare una classe che accetta il dizionario precedente ed implementi I metodi:
#~ Lettura da file
#~ Stampa dei voti di uno studente
#~ Calcolo della media di uno studente
#~ Restituire una lista di tutti gli studenti che hanno sostenuto un esame
#~ Restituire la lista degli studenti con piu' di 5 esami


class StudentiDB:
    """crea una classe per interrogare un dizionario di studenti"""
    def __init__(self, db={}):
        """inizializza la classe"""
        self.db=db
    
    def leggi(self,filename):
        """legge il db da file. ipotizzo che ogni riga sia del tipo 'matricola,nomesame, voto' """
        self.db={}
        with open(filename) as f:
            for line in f:
                a,b,c = line.split(',')
                if a in self.db:
                    self.db[a].append( (b,c) )
                else:
                    self.db[a]=[(b,c)]
    
    def salva_sufile(self, filename):
        """salva su file"""
        with open(filename, 'w') as f:
            for key in self.db:
                for a,b in self.db[k]:
                    f.write('%s,%s,%s\n'%(key, a,b))
    
    def stampa_voti(self, matricola):
        """stampa i voti di uno studente"""
        if matricola not in self.db:
            print 'lo studente non esiste'
            return
        for a,b in self.db[matricola]:
            print a,b
    
    def get_media(self, matricola):
        """ritorna la media esami"""
        if matricola not in self.db:
            print 'lo studente non esiste'
            return
        
        esami=self.db[matricola]
        return sum([voto for ex,voto in esami])/float(len(esami))
    
    def get_lista_studenti(self, esame):
        """ritorna la lista degli studenti che hanno sostenuto l'esame"""
        result=[]
        for k in self.db:
            for a,b in self.db[k]:
                if a==esame:
                    result.append(k)
                    break
        return result
    
    def get_studenti_more5_esami(self):
        """restituisce la lista degli studenti con + di 5 esami"""
        return [k for k in self.db if len(self.db[k])>5]
    
    def __str__(self):
        return self.db.__str__()
        
if __name__ == '__main__':
    obj=StudentiDB()
    obj.db={12345:[('esame1',25),('esame2',23),('esame3',25),('esame4',29),('esame5',26),('esame6',26)],
        98765:[('esame1',25),('esame2',22),]}
    print obj
    print 'stampo i voti di 12345'
    obj.stampa_voti(12345)
    print 'media di 12345 =',obj.get_media(12345)
    print 'lista studenti con esame1:',obj.get_lista_studenti('esame1')
    print 'studenti con + di 5 esami:', obj.get_studenti_more5_esami()
        
        
    
                